diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
new file mode 100644
index 649a233..d47f635
*** a/src/backend/optimizer/plan/planner.c
--- b/src/backend/optimizer/plan/planner.c
*************** typedef struct
*** 108,117 ****
--- 108,135 ----
  	int		   *tleref_to_colnum_map;
  } grouping_sets_data;
  
+ /* Result of a given invocation of inheritance_planner_guts() */
+ typedef struct
+ {
+ 	Index 	nominalRelation;
+ 	List   *partitioned_rels;
+ 	List   *resultRelations;
+ 	List   *subpaths;
+ 	List   *subroots;
+ 	List   *withCheckOptionLists;
+ 	List   *returningLists;
+ 	List   *final_rtable;
+ 	List   *init_plans;
+ 	int		save_rel_array_size;
+ 	RelOptInfo **save_rel_array;
+ } inheritance_planner_result;
+ 
  /* Local functions */
  static Node *preprocess_expression(PlannerInfo *root, Node *expr, int kind);
  static void preprocess_qual_conditions(PlannerInfo *root, Node *jtnode);
  static void inheritance_planner(PlannerInfo *root);
+ static void inheritance_planner_guts(PlannerInfo *root,
+ 						 inheritance_planner_result *inhpres);
  static void grouping_planner(PlannerInfo *root, bool inheritance_update,
  				 double tuple_fraction);
  static grouping_sets_data *preprocess_grouping_sets(PlannerInfo *root);
*************** static void standard_qp_callback(Planner
*** 130,138 ****
  static double get_number_of_groups(PlannerInfo *root,
  					 double path_rows,
  					 grouping_sets_data *gd);
- static Size estimate_hashagg_tablesize(Path *path,
- 						   const AggClauseCosts *agg_costs,
- 						   double dNumGroups);
  static RelOptInfo *create_grouping_paths(PlannerInfo *root,
  					  RelOptInfo *input_rel,
  					  PathTarget *target,
--- 148,153 ----
*************** preprocess_phv_expression(PlannerInfo *r
*** 1020,1044 ****
  static void
  inheritance_planner(PlannerInfo *root)
  {
  	Query	   *parse = root->parse;
  	int			parentRTindex = parse->resultRelation;
  	Bitmapset  *subqueryRTindexes;
  	Bitmapset  *modifiableARIindexes;
! 	int			nominalRelation = -1;
! 	List	   *final_rtable = NIL;
! 	int			save_rel_array_size = 0;
! 	RelOptInfo **save_rel_array = NULL;
! 	List	   *subpaths = NIL;
! 	List	   *subroots = NIL;
! 	List	   *resultRelations = NIL;
! 	List	   *withCheckOptionLists = NIL;
! 	List	   *returningLists = NIL;
! 	List	   *rowMarks;
! 	RelOptInfo *final_rel;
  	ListCell   *lc;
  	Index		rti;
  	RangeTblEntry *parent_rte;
- 	List		  *partitioned_rels = NIL;
  
  	Assert(parse->commandType != CMD_INSERT);
  
--- 1035,1139 ----
  static void
  inheritance_planner(PlannerInfo *root)
  {
+ 	inheritance_planner_result inhpres;
+ 	Query	   *parse = root->parse;
+ 	RelOptInfo *final_rel;
+ 	Index		rti;
+ 	int			final_rtable_len;
+ 	ListCell   *lc;
+ 	List	   *rowMarks;
+ 
+ 	/*
+ 	 * Away we go... Although the inheritance hierarchy to be processed might
+ 	 * be represented in a non-flat manner, some of the elements needed to
+ 	 * create the final ModifyTable path are always returned in a flat list
+ 	 * structure.
+ 	 */
+ 	memset(&inhpres, 0, sizeof(inhpres));
+ 	inheritance_planner_guts(root, &inhpres);
+ 
+ 	/* Result path must go into outer query's FINAL upperrel */
+ 	final_rel = fetch_upper_rel(root, UPPERREL_FINAL, NULL);
+ 
+ 	/*
+ 	 * We don't currently worry about setting final_rel's consider_parallel
+ 	 * flag in this case, nor about allowing FDWs or create_upper_paths_hook
+ 	 * to get control here.
+ 	 */
+ 
+ 	/*
+ 	 * If we managed to exclude every child rel, return a dummy plan; it
+ 	 * doesn't even need a ModifyTable node.
+ 	 */
+ 	if (inhpres.subpaths == NIL)
+ 	{
+ 		set_dummy_rel_pathlist(final_rel);
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Put back the final adjusted rtable into the master copy of the Query.
+ 	 * (We mustn't do this if we found no non-excluded children.)
+ 	 */
+ 	parse->rtable = inhpres.final_rtable;
+ 	root->simple_rel_array_size = inhpres.save_rel_array_size;
+ 	root->simple_rel_array = inhpres.save_rel_array;
+ 	/* Must reconstruct master's simple_rte_array, too */
+ 	final_rtable_len = list_length(inhpres.final_rtable);
+ 	root->simple_rte_array = (RangeTblEntry **)
+ 								palloc0((final_rtable_len + 1) *
+ 											sizeof(RangeTblEntry *));
+ 	rti = 1;
+ 	foreach(lc, inhpres.final_rtable)
+ 	{
+ 		RangeTblEntry *rte = (RangeTblEntry *) lfirst(lc);
+ 
+ 		root->simple_rte_array[rti++] = rte;
+ 	}
+ 
+ 	/*
+ 	 * If there was a FOR [KEY] UPDATE/SHARE clause, the LockRows node will
+ 	 * have dealt with fetching non-locked marked rows, else we need to have
+ 	 * ModifyTable do that.
+ 	 */
+ 	if (parse->rowMarks)
+ 		rowMarks = NIL;
+ 	else
+ 		rowMarks = root->rowMarks;
+ 
+ 	/* Create Path representing a ModifyTable to do the UPDATE/DELETE work */
+ 	add_path(final_rel, (Path *)
+ 			 create_modifytable_path(root, final_rel,
+ 									 parse->commandType,
+ 									 parse->canSetTag,
+ 									 inhpres.nominalRelation,
+ 									 inhpres.partitioned_rels,
+ 									 inhpres.resultRelations,
+ 									 inhpres.subpaths,
+ 									 inhpres.subroots,
+ 									 inhpres.withCheckOptionLists,
+ 									 inhpres.returningLists,
+ 									 rowMarks,
+ 									 NULL,
+ 									 SS_assign_special_param(root)), false);
+ }
+ 
+ /*
+  * inheritance_planner_guts
+  *	  Recursive guts of inheritance_planner
+  */
+ static void
+ inheritance_planner_guts(PlannerInfo *root,
+ 						 inheritance_planner_result *inhpres)
+ {
  	Query	   *parse = root->parse;
  	int			parentRTindex = parse->resultRelation;
  	Bitmapset  *subqueryRTindexes;
  	Bitmapset  *modifiableARIindexes;
! 	bool		nominalRelationSet = false;
  	ListCell   *lc;
  	Index		rti;
  	RangeTblEntry *parent_rte;
  
  	Assert(parse->commandType != CMD_INSERT);
  
*************** inheritance_planner(PlannerInfo *root)
*** 1106,1112 ****
  	 */
  	parent_rte = rt_fetch(parentRTindex, root->parse->rtable);
  	if (parent_rte->relkind == RELKIND_PARTITIONED_TABLE)
! 		nominalRelation = parentRTindex;
  
  	/*
  	 * And now we can get on with generating a plan for each child table.
--- 1201,1210 ----
  	 */
  	parent_rte = rt_fetch(parentRTindex, root->parse->rtable);
  	if (parent_rte->relkind == RELKIND_PARTITIONED_TABLE)
! 	{
! 		inhpres->nominalRelation = parentRTindex;
! 		nominalRelationSet = true;
! 	}
  
  	/*
  	 * And now we can get on with generating a plan for each child table.
*************** inheritance_planner(PlannerInfo *root)
*** 1115,1120 ****
--- 1213,1219 ----
  	{
  		AppendRelInfo *appinfo = (AppendRelInfo *) lfirst(lc);
  		PlannerInfo *subroot;
+ 		Index	childRTindex = appinfo->child_relid;
  		RangeTblEntry *child_rte;
  		RelOptInfo *sub_final_rel;
  		Path	   *subpath;
*************** inheritance_planner(PlannerInfo *root)
*** 1136,1152 ****
  		 * references to the parent RTE to refer to the current child RTE,
  		 * then fool around with subquery RTEs.
  		 */
! 		subroot->parse = (Query *)
! 			adjust_appendrel_attrs(root,
! 								   (Node *) parse,
! 								   appinfo);
  
  		/*
  		 * If there are securityQuals attached to the parent, move them to the
  		 * child rel (they've already been transformed properly for that).
  		 */
  		parent_rte = rt_fetch(parentRTindex, subroot->parse->rtable);
! 		child_rte = rt_fetch(appinfo->child_relid, subroot->parse->rtable);
  		child_rte->securityQuals = parent_rte->securityQuals;
  		parent_rte->securityQuals = NIL;
  
--- 1235,1249 ----
  		 * references to the parent RTE to refer to the current child RTE,
  		 * then fool around with subquery RTEs.
  		 */
! 		subroot->parse = (Query *) adjust_appendrel_attrs(root, (Node *) parse,
! 														  1, &appinfo);
  
  		/*
  		 * If there are securityQuals attached to the parent, move them to the
  		 * child rel (they've already been transformed properly for that).
  		 */
  		parent_rte = rt_fetch(parentRTindex, subroot->parse->rtable);
! 		child_rte = rt_fetch(childRTindex, subroot->parse->rtable);
  		child_rte->securityQuals = parent_rte->securityQuals;
  		parent_rte->securityQuals = NIL;
  
*************** inheritance_planner(PlannerInfo *root)
*** 1191,1197 ****
  		 * These won't be referenced, so there's no need to make them very
  		 * valid-looking.
  		 */
! 		while (list_length(subroot->parse->rtable) < list_length(final_rtable))
  			subroot->parse->rtable = lappend(subroot->parse->rtable,
  											 makeNode(RangeTblEntry));
  
--- 1288,1295 ----
  		 * These won't be referenced, so there's no need to make them very
  		 * valid-looking.
  		 */
! 		while (list_length(subroot->parse->rtable) <
! 										list_length(inhpres->final_rtable))
  			subroot->parse->rtable = lappend(subroot->parse->rtable,
  											 makeNode(RangeTblEntry));
  
*************** inheritance_planner(PlannerInfo *root)
*** 1203,1209 ****
  		 * since subquery RTEs couldn't contain any references to the target
  		 * rel.
  		 */
! 		if (final_rtable != NIL && subqueryRTindexes != NULL)
  		{
  			ListCell   *lr;
  
--- 1301,1307 ----
  		 * since subquery RTEs couldn't contain any references to the target
  		 * rel.
  		 */
! 		if (inhpres->final_rtable != NIL && subqueryRTindexes != NULL)
  		{
  			ListCell   *lr;
  
*************** inheritance_planner(PlannerInfo *root)
*** 1248,1253 ****
--- 1346,1392 ----
  			}
  		}
  
+ 		/*
+ 		 * Recurse for a partitioned child table.  We shouldn't be planning
+ 		 * a partitioned RTE as a child member, which is what the code after
+ 		 * this block does.
+ 		 */
+ 		if (child_rte->inh)
+ 		{
+ 			inheritance_planner_result	child_inhpres;
+ 
+ 			Assert(child_rte->relkind == RELKIND_PARTITIONED_TABLE);
+ 
+ 			/* During the recursive invocation, this child is the parent. */
+ 			subroot->parse->resultRelation = childRTindex;
+ 			memset(&child_inhpres, 0, sizeof(child_inhpres));
+ 			inheritance_planner_guts(subroot, &child_inhpres);
+ 
+ 			inhpres->partitioned_rels = list_concat(inhpres->partitioned_rels,
+ 											child_inhpres.partitioned_rels);
+ 			inhpres->resultRelations = list_concat(inhpres->resultRelations,
+ 											child_inhpres.resultRelations);
+ 			inhpres->subpaths = list_concat(inhpres->subpaths,
+ 											child_inhpres.subpaths);
+ 			inhpres->subroots = list_concat(inhpres->subroots,
+ 											child_inhpres.subroots);
+ 			inhpres->withCheckOptionLists =
+ 									list_concat(inhpres->withCheckOptionLists,
+ 										child_inhpres.withCheckOptionLists);
+ 			inhpres->returningLists = list_concat(inhpres->returningLists,
+ 											child_inhpres.returningLists);
+ 			if (child_inhpres.final_rtable != NIL)
+ 				inhpres->final_rtable = child_inhpres.final_rtable;
+ 			if (child_inhpres.init_plans != NIL)
+ 				inhpres->init_plans = child_inhpres.init_plans;
+ 			if (child_inhpres.save_rel_array_size != 0)
+ 			{
+ 				inhpres->save_rel_array_size = child_inhpres.save_rel_array_size;
+ 				inhpres->save_rel_array = child_inhpres.save_rel_array;
+ 			}
+ 			continue;
+ 		}
+ 
  		/* There shouldn't be any OJ info to translate, as yet */
  		Assert(subroot->join_info_list == NIL);
  		/* and we haven't created PlaceHolderInfos, either */
*************** inheritance_planner(PlannerInfo *root)
*** 1279,1286 ****
  		 * the duplicate child RTE added for the parent does not appear
  		 * anywhere else in the plan tree.
  		 */
! 		if (nominalRelation < 0)
! 			nominalRelation = appinfo->child_relid;
  
  		/*
  		 * Select cheapest path in case there's more than one.  We always run
--- 1418,1428 ----
  		 * the duplicate child RTE added for the parent does not appear
  		 * anywhere else in the plan tree.
  		 */
! 		if (!nominalRelationSet)
! 		{
! 			inhpres->nominalRelation = childRTindex;
! 			nominalRelationSet = true;
! 		}
  
  		/*
  		 * Select cheapest path in case there's more than one.  We always run
*************** inheritance_planner(PlannerInfo *root)
*** 1303,1314 ****
  		 * becomes the initial contents of final_rtable; otherwise, append
  		 * just its modified subquery RTEs to final_rtable.
  		 */
! 		if (final_rtable == NIL)
! 			final_rtable = subroot->parse->rtable;
  		else
! 			final_rtable = list_concat(final_rtable,
! 									   list_copy_tail(subroot->parse->rtable,
! 												 list_length(final_rtable)));
  
  		/*
  		 * We need to collect all the RelOptInfos from all child plans into
--- 1445,1456 ----
  		 * becomes the initial contents of final_rtable; otherwise, append
  		 * just its modified subquery RTEs to final_rtable.
  		 */
! 		if (inhpres->final_rtable == NIL)
! 			inhpres->final_rtable = subroot->parse->rtable;
  		else
! 			inhpres->final_rtable = list_concat(inhpres->final_rtable,
! 										list_copy_tail(subroot->parse->rtable,
! 										 list_length(inhpres->final_rtable)));
  
  		/*
  		 * We need to collect all the RelOptInfos from all child plans into
*************** inheritance_planner(PlannerInfo *root)
*** 1317,1425 ****
  		 * have to propagate forward the RelOptInfos that were already built
  		 * in previous children.
  		 */
! 		Assert(subroot->simple_rel_array_size >= save_rel_array_size);
! 		for (rti = 1; rti < save_rel_array_size; rti++)
  		{
! 			RelOptInfo *brel = save_rel_array[rti];
  
  			if (brel)
  				subroot->simple_rel_array[rti] = brel;
  		}
! 		save_rel_array_size = subroot->simple_rel_array_size;
! 		save_rel_array = subroot->simple_rel_array;
  
  		/* Make sure any initplans from this rel get into the outer list */
! 		root->init_plans = subroot->init_plans;
  
  		/* Build list of sub-paths */
! 		subpaths = lappend(subpaths, subpath);
  
  		/* Build list of modified subroots, too */
! 		subroots = lappend(subroots, subroot);
  
  		/* Build list of target-relation RT indexes */
! 		resultRelations = lappend_int(resultRelations, appinfo->child_relid);
  
  		/* Build lists of per-relation WCO and RETURNING targetlists */
  		if (parse->withCheckOptions)
! 			withCheckOptionLists = lappend(withCheckOptionLists,
! 										   subroot->parse->withCheckOptions);
  		if (parse->returningList)
! 			returningLists = lappend(returningLists,
! 									 subroot->parse->returningList);
! 
  		Assert(!parse->onConflict);
  	}
  
  	if (parent_rte->relkind == RELKIND_PARTITIONED_TABLE)
  	{
! 		partitioned_rels = get_partitioned_child_rels(root, parentRTindex);
  		/* The root partitioned table is included as a child rel */
! 		Assert(list_length(partitioned_rels) >= 1);
! 	}
! 
! 	/* Result path must go into outer query's FINAL upperrel */
! 	final_rel = fetch_upper_rel(root, UPPERREL_FINAL, NULL);
! 
! 	/*
! 	 * We don't currently worry about setting final_rel's consider_parallel
! 	 * flag in this case, nor about allowing FDWs or create_upper_paths_hook
! 	 * to get control here.
! 	 */
! 
! 	/*
! 	 * If we managed to exclude every child rel, return a dummy plan; it
! 	 * doesn't even need a ModifyTable node.
! 	 */
! 	if (subpaths == NIL)
! 	{
! 		set_dummy_rel_pathlist(final_rel);
! 		return;
! 	}
! 
! 	/*
! 	 * Put back the final adjusted rtable into the master copy of the Query.
! 	 * (We mustn't do this if we found no non-excluded children.)
! 	 */
! 	parse->rtable = final_rtable;
! 	root->simple_rel_array_size = save_rel_array_size;
! 	root->simple_rel_array = save_rel_array;
! 	/* Must reconstruct master's simple_rte_array, too */
! 	root->simple_rte_array = (RangeTblEntry **)
! 		palloc0((list_length(final_rtable) + 1) * sizeof(RangeTblEntry *));
! 	rti = 1;
! 	foreach(lc, final_rtable)
! 	{
! 		RangeTblEntry *rte = (RangeTblEntry *) lfirst(lc);
! 
! 		root->simple_rte_array[rti++] = rte;
  	}
- 
- 	/*
- 	 * If there was a FOR [KEY] UPDATE/SHARE clause, the LockRows node will
- 	 * have dealt with fetching non-locked marked rows, else we need to have
- 	 * ModifyTable do that.
- 	 */
- 	if (parse->rowMarks)
- 		rowMarks = NIL;
- 	else
- 		rowMarks = root->rowMarks;
- 
- 	/* Create Path representing a ModifyTable to do the UPDATE/DELETE work */
- 	add_path(final_rel, (Path *)
- 			 create_modifytable_path(root, final_rel,
- 									 parse->commandType,
- 									 parse->canSetTag,
- 									 nominalRelation,
- 									 partitioned_rels,
- 									 resultRelations,
- 									 subpaths,
- 									 subroots,
- 									 withCheckOptionLists,
- 									 returningLists,
- 									 rowMarks,
- 									 NULL,
- 									 SS_assign_special_param(root)));
  }
  
  /*--------------------
--- 1459,1506 ----
  		 * have to propagate forward the RelOptInfos that were already built
  		 * in previous children.
  		 */
! 		Assert(subroot->simple_rel_array_size >= inhpres->save_rel_array_size);
! 		for (rti = 1; rti < inhpres->save_rel_array_size; rti++)
  		{
! 			RelOptInfo *brel = inhpres->save_rel_array[rti];
  
  			if (brel)
  				subroot->simple_rel_array[rti] = brel;
  		}
! 		inhpres->save_rel_array_size = subroot->simple_rel_array_size;
! 		inhpres->save_rel_array = subroot->simple_rel_array;
  
  		/* Make sure any initplans from this rel get into the outer list */
! 		inhpres->init_plans = subroot->init_plans;
  
  		/* Build list of sub-paths */
! 		inhpres->subpaths = lappend(inhpres->subpaths, subpath);
  
  		/* Build list of modified subroots, too */
! 		inhpres->subroots = lappend(inhpres->subroots, subroot);
  
  		/* Build list of target-relation RT indexes */
! 		inhpres->resultRelations = lappend_int(inhpres->resultRelations,
! 											   childRTindex);
  
  		/* Build lists of per-relation WCO and RETURNING targetlists */
  		if (parse->withCheckOptions)
! 			inhpres->withCheckOptionLists =
! 										lappend(inhpres->withCheckOptionLists,
! 											subroot->parse->withCheckOptions);
  		if (parse->returningList)
! 			inhpres->returningLists = lappend(inhpres->returningLists,
! 											  subroot->parse->returningList);
  		Assert(!parse->onConflict);
  	}
  
  	if (parent_rte->relkind == RELKIND_PARTITIONED_TABLE)
  	{
! 		inhpres->partitioned_rels = get_partitioned_child_rels(root,
! 															parentRTindex);
  		/* The root partitioned table is included as a child rel */
! 		Assert(list_length(inhpres->partitioned_rels) >= 1);
  	}
  }
  
  /*--------------------
*************** grouping_planner(PlannerInfo *root, bool
*** 2040,2046 ****
  		}
  
  		/* And shove it into final_rel */
! 		add_path(final_rel, path);
  	}
  
  	/*
--- 2121,2127 ----
  		}
  
  		/* And shove it into final_rel */
! 		add_path(final_rel, path, false);
  	}
  
  	/*
*************** get_number_of_groups(PlannerInfo *root,
*** 3446,3485 ****
  }
  
  /*
-  * estimate_hashagg_tablesize
-  *	  estimate the number of bytes that a hash aggregate hashtable will
-  *	  require based on the agg_costs, path width and dNumGroups.
-  *
-  * XXX this may be over-estimating the size now that hashagg knows to omit
-  * unneeded columns from the hashtable. Also for mixed-mode grouping sets,
-  * grouping columns not in the hashed set are counted here even though hashagg
-  * won't store them. Is this a problem?
-  */
- static Size
- estimate_hashagg_tablesize(Path *path, const AggClauseCosts *agg_costs,
- 						   double dNumGroups)
- {
- 	Size		hashentrysize;
- 
- 	/* Estimate per-hash-entry space at tuple width... */
- 	hashentrysize = MAXALIGN(path->pathtarget->width) +
- 		MAXALIGN(SizeofMinimalTupleHeader);
- 
- 	/* plus space for pass-by-ref transition values... */
- 	hashentrysize += agg_costs->transitionSpace;
- 	/* plus the per-hash-entry overhead */
- 	hashentrysize += hash_agg_entry_size(agg_costs->numAggs);
- 
- 	/*
- 	 * Note that this disregards the effect of fill-factor and growth policy
- 	 * of the hash-table. That's probably ok, given default the default
- 	 * fill-factor is relatively high. It'd be hard to meaningfully factor in
- 	 * "double-in-size" growth policies here.
- 	 */
- 	return hashentrysize * dNumGroups;
- }
- 
- /*
   * create_grouping_paths
   *
   * Build a new upperrel containing Paths for grouping and/or aggregation.
--- 3527,3532 ----
*************** create_grouping_paths(PlannerInfo *root,
*** 3600,3606 ****
  								   (List *) parse->havingQual);
  		}
  
! 		add_path(grouped_rel, path);
  
  		/* No need to consider any other alternatives. */
  		set_cheapest(grouped_rel);
--- 3647,3653 ----
  								   (List *) parse->havingQual);
  		}
  
! 		add_path(grouped_rel, path, false);
  
  		/* No need to consider any other alternatives. */
  		set_cheapest(grouped_rel);
*************** create_grouping_paths(PlannerInfo *root,
*** 3777,3783 ****
  														 parse->groupClause,
  														 NIL,
  														 &agg_partial_costs,
! 														 dNumPartialGroups));
  					else
  						add_partial_path(grouped_rel, (Path *)
  										 create_group_path(root,
--- 3824,3831 ----
  														 parse->groupClause,
  														 NIL,
  														 &agg_partial_costs,
! 														 dNumPartialGroups),
! 							false);
  					else
  						add_partial_path(grouped_rel, (Path *)
  										 create_group_path(root,
*************** create_grouping_paths(PlannerInfo *root,
*** 3786,3792 ****
  													 partial_grouping_target,
  														   parse->groupClause,
  														   NIL,
! 														 dNumPartialGroups));
  				}
  			}
  		}
--- 3834,3841 ----
  													 partial_grouping_target,
  														   parse->groupClause,
  														   NIL,
! 														   dNumPartialGroups),
! 										 false);
  				}
  			}
  		}
*************** create_grouping_paths(PlannerInfo *root,
*** 3817,3823 ****
  												 parse->groupClause,
  												 NIL,
  												 &agg_partial_costs,
! 												 dNumPartialGroups));
  			}
  		}
  	}
--- 3866,3873 ----
  												 parse->groupClause,
  												 NIL,
  												 &agg_partial_costs,
! 												 dNumPartialGroups),
! 								 false);
  			}
  		}
  	}
*************** create_grouping_paths(PlannerInfo *root,
*** 3869,3875 ****
  											 parse->groupClause,
  											 (List *) parse->havingQual,
  											 agg_costs,
! 											 dNumGroups));
  				}
  				else if (parse->groupClause)
  				{
--- 3919,3925 ----
  											 parse->groupClause,
  											 (List *) parse->havingQual,
  											 agg_costs,
! 											 dNumGroups), false);
  				}
  				else if (parse->groupClause)
  				{
*************** create_grouping_paths(PlannerInfo *root,
*** 3884,3890 ****
  											   target,
  											   parse->groupClause,
  											   (List *) parse->havingQual,
! 											   dNumGroups));
  				}
  				else
  				{
--- 3934,3940 ----
  											   target,
  											   parse->groupClause,
  											   (List *) parse->havingQual,
! 											   dNumGroups), false);
  				}
  				else
  				{
*************** create_grouping_paths(PlannerInfo *root,
*** 3933,3939 ****
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 &agg_final_costs,
! 										 dNumGroups));
  			else
  				add_path(grouped_rel, (Path *)
  						 create_group_path(root,
--- 3983,3989 ----
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 &agg_final_costs,
! 										 dNumGroups), false);
  			else
  				add_path(grouped_rel, (Path *)
  						 create_group_path(root,
*************** create_grouping_paths(PlannerInfo *root,
*** 3942,3948 ****
  										   target,
  										   parse->groupClause,
  										   (List *) parse->havingQual,
! 										   dNumGroups));
  
  			/*
  			 * The point of using Gather Merge rather than Gather is that it
--- 3992,3998 ----
  										   target,
  										   parse->groupClause,
  										   (List *) parse->havingQual,
! 										   dNumGroups), false);
  
  			/*
  			 * The point of using Gather Merge rather than Gather is that it
*************** create_grouping_paths(PlannerInfo *root,
*** 3995,4001 ****
  												 parse->groupClause,
  												 (List *) parse->havingQual,
  												 &agg_final_costs,
! 												 dNumGroups));
  					else
  						add_path(grouped_rel, (Path *)
  								 create_group_path(root,
--- 4045,4051 ----
  												 parse->groupClause,
  												 (List *) parse->havingQual,
  												 &agg_final_costs,
! 												 dNumGroups), false);
  					else
  						add_path(grouped_rel, (Path *)
  								 create_group_path(root,
*************** create_grouping_paths(PlannerInfo *root,
*** 4004,4010 ****
  												   target,
  												   parse->groupClause,
  												   (List *) parse->havingQual,
! 												   dNumGroups));
  				}
  			}
  		}
--- 4054,4060 ----
  												   target,
  												   parse->groupClause,
  												   (List *) parse->havingQual,
! 												   dNumGroups), false);
  				}
  			}
  		}
*************** create_grouping_paths(PlannerInfo *root,
*** 4049,4055 ****
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 agg_costs,
! 										 dNumGroups));
  			}
  		}
  
--- 4099,4105 ----
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 agg_costs,
! 										 dNumGroups), false);
  			}
  		}
  
*************** create_grouping_paths(PlannerInfo *root,
*** 4087,4095 ****
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 &agg_final_costs,
! 										 dNumGroups));
  			}
  		}
  	}
  
  	/* Give a helpful error if we failed to find any implementation */
--- 4137,4212 ----
  										 parse->groupClause,
  										 (List *) parse->havingQual,
  										 &agg_final_costs,
! 										 dNumGroups), false);
  			}
  		}
+ 
+ 		/*
+ 		 * If input_rel has partially aggregated partial paths, gather them
+ 		 * and perform the final aggregation.
+ 		 *
+ 		 * TODO Allow havingQual - currently not supported at base relation
+ 		 * level.
+ 		 */
+ 		if (input_rel->gpi != NULL &&
+ 			input_rel->gpi->partial_pathlist != NIL &&
+ 			!parse->havingQual)
+ 		{
+ 			Path	   *path = (Path *) linitial(input_rel->gpi->partial_pathlist);
+ 			double		total_groups = path->rows * path->parallel_workers;
+ 
+ 			path = (Path *) create_gather_path(root,
+ 											   input_rel,
+ 											   path,
+ 											   path->pathtarget,
+ 											   NULL,
+ 											   &total_groups);
+ 
+ 			/*
+ 			 * The input path is partially aggregated and the final
+ 			 * aggregation - if the path wins - will be done below. So we're
+ 			 * done with it for now.
+ 			 *
+ 			 * The top-level grouped_rel needs to receive the path into
+ 			 * regular pathlist, as opposed grouped_rel->gpi->pathlist.
+ 			 */
+ 			add_path(input_rel, path, false);
+ 		}
+ 
+ 		/*
+ 		 * If input_rel has partially aggregated paths, perform the final
+ 		 * aggregation.
+ 		 *
+ 		 * TODO Allow havingQual - currently not supported at base relation
+ 		 * level.
+ 		 */
+ 		if (input_rel->gpi != NULL && input_rel->gpi->pathlist != NIL &&
+ 			!parse->havingQual)
+ 		{
+ 			Path *pre_agg = (Path *) linitial(input_rel->gpi->pathlist);
+ 
+ 			dNumGroups = get_number_of_groups(root, pre_agg->rows, gd);
+ 
+ 			MemSet(&agg_final_costs, 0, sizeof(AggClauseCosts));
+ 			get_agg_clause_costs(root, (Node *) target->exprs,
+ 								 AGGSPLIT_FINAL_DESERIAL,
+ 								 &agg_final_costs);
+ 			get_agg_clause_costs(root, parse->havingQual,
+ 								 AGGSPLIT_FINAL_DESERIAL,
+ 								 &agg_final_costs);
+ 
+ 			add_path(grouped_rel,
+ 					 (Path *) create_agg_path(root, grouped_rel,
+ 											  pre_agg,
+ 											  target,
+ 											  AGG_HASHED,
+ 											  AGGSPLIT_FINAL_DESERIAL,
+ 											  parse->groupClause,
+ 											  (List *) parse->havingQual,
+ 											  &agg_final_costs,
+ 											  dNumGroups),
+ 					 false);
+ 		}
  	}
  
  	/* Give a helpful error if we failed to find any implementation */
*************** consider_groupingsets_paths(PlannerInfo
*** 4289,4295 ****
  										  strat,
  										  new_rollups,
  										  agg_costs,
! 										  dNumGroups));
  		return;
  	}
  
--- 4406,4412 ----
  										  strat,
  										  new_rollups,
  										  agg_costs,
! 										  dNumGroups), false);
  		return;
  	}
  
*************** consider_groupingsets_paths(PlannerInfo
*** 4447,4453 ****
  											  AGG_MIXED,
  											  rollups,
  											  agg_costs,
! 											  dNumGroups));
  		}
  	}
  
--- 4564,4570 ----
  											  AGG_MIXED,
  											  rollups,
  											  agg_costs,
! 											  dNumGroups), false);
  		}
  	}
  
*************** consider_groupingsets_paths(PlannerInfo
*** 4464,4470 ****
  										  AGG_SORTED,
  										  gd->rollups,
  										  agg_costs,
! 										  dNumGroups));
  }
  
  /*
--- 4581,4587 ----
  										  AGG_SORTED,
  										  gd->rollups,
  										  agg_costs,
! 										  dNumGroups), false);
  }
  
  /*
*************** create_one_window_path(PlannerInfo *root
*** 4649,4655 ****
  								  window_pathkeys);
  	}
  
! 	add_path(window_rel, path);
  }
  
  /*
--- 4766,4772 ----
  								  window_pathkeys);
  	}
  
! 	add_path(window_rel, path, false);
  }
  
  /*
*************** create_distinct_paths(PlannerInfo *root,
*** 4755,4761 ****
  						 create_upper_unique_path(root, distinct_rel,
  												  path,
  										list_length(root->distinct_pathkeys),
! 												  numDistinctRows));
  			}
  		}
  
--- 4872,4878 ----
  						 create_upper_unique_path(root, distinct_rel,
  												  path,
  										list_length(root->distinct_pathkeys),
! 												  numDistinctRows), false);
  			}
  		}
  
*************** create_distinct_paths(PlannerInfo *root,
*** 4782,4788 ****
  				 create_upper_unique_path(root, distinct_rel,
  										  path,
  										list_length(root->distinct_pathkeys),
! 										  numDistinctRows));
  	}
  
  	/*
--- 4899,4905 ----
  				 create_upper_unique_path(root, distinct_rel,
  										  path,
  										list_length(root->distinct_pathkeys),
! 										  numDistinctRows), false);
  	}
  
  	/*
*************** create_distinct_paths(PlannerInfo *root,
*** 4829,4835 ****
  								 parse->distinctClause,
  								 NIL,
  								 NULL,
! 								 numDistinctRows));
  	}
  
  	/* Give a helpful error if we failed to find any implementation */
--- 4946,4952 ----
  								 parse->distinctClause,
  								 NIL,
  								 NULL,
! 								 numDistinctRows), false);
  	}
  
  	/* Give a helpful error if we failed to find any implementation */
*************** create_ordered_paths(PlannerInfo *root,
*** 4927,4933 ****
  				path = apply_projection_to_path(root, ordered_rel,
  												path, target);
  
! 			add_path(ordered_rel, path);
  		}
  	}
  
--- 5044,5050 ----
  				path = apply_projection_to_path(root, ordered_rel,
  												path, target);
  
! 			add_path(ordered_rel, path, false);
  		}
  	}
  
*************** create_ordered_paths(PlannerInfo *root,
*** 4977,4983 ****
  				path = apply_projection_to_path(root, ordered_rel,
  												path, target);
  
! 			add_path(ordered_rel, path);
  		}
  	}
  
--- 5094,5100 ----
  				path = apply_projection_to_path(root, ordered_rel,
  												path, target);
  
! 			add_path(ordered_rel, path, false);
  		}
  	}
  
